program read50x;        { PIC12C508 read for Turbo Pascal 6.0 - Ver 1.2 }
                        { Copyright (c) 1997-1998, Jens Dyekjr Madsen  }

uses errmsg60,jdm84io,jdm84pgm,inthex;          { Used units            }
const
  blank=$fff;

var
  size1: 1..$1000;                              { Total Size            }
  cfgword: word;                                { Configuration word    }
  userpgm: array[0..$fff] of word;              { Program mem incl. id. }
  f: text;                                      { IHX test file         }
  com: byte;                                    { Communication port    }
  i: word;                                      { Store code from val   }
  fn: string;                                   { IHX8 filename         }
  oscadr: 0..$fff;
  oscdat: word;

begin
  if paramcount<>4 then                         { Check Parameters      }
  begin                                         { Else help             }
    writeln('Use:');
    writeln('   read50x totalsize oscadr+1 filename.hex comport');
    halt;
  end;
{$r+}
  val(paramstr(1), size1, i);                   { Read total size       }
  val(paramstr(2), oscadr, i);
{$r-}
  val(paramstr(4), com, i);
  setcom(com);                                  { Set com port          }
  if err<>0 then                                { Check if any error    }
  begin
    writeln(errtxt[err]);                       { Write error message   }
    halt;                                       { Stop execution if err }
  end;

  fn:=paramstr(3);                              { Filename from paramstr}
  writeln('Reading PIC12C50X at COM',com,' to ''',fn,'''');     { Info  }

  fnameptr:=@fn;                                { Set filename pointer  }
  assign(f,fn);                                 { Open file             }
  rewrite(f);                                   { Write mode            }

  rdmem(userpgm, incadr, readpgm, size1);       { Read code memory + id }
  rdmem(cfgword, null, readpgm, 1);             { Read configuration    }
  releasepg;                                    { End of programming    }

  if oscadr<>0 then                             { Check if oscadr valid }
  begin
    oscdat:=userpgm[pred(oscadr)];              { Get osc-value data    }
    write('--- Notice: Oscilator calibration value: '); { Output text   }
    if hi(oscdat)<>$0c then write('(',hi(oscdat),') '); { Print value   }
    writeln(lo(oscdat),' ---');
  end;

  ihxwrite(f, userpgm, $0000, 2*size1);         { Write userpgm, 0, $204}
  ihxwrite(f, cfgword, $1ffe, 2);               { Write id's, $FFF, 1   }
  ihxendwrite(f);                               { Write end of record   }
  close(f);                                     { Close file            }
  fnameptr:=NIL;                                { End of using filename }
end.
